"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.I18nProvider = void 0;

var i18n = _interopRequireWildcard(require("../core"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class I18nProvider {
  constructor() {
    _defineProperty(this, "addTranslation", i18n.addTranslation);

    _defineProperty(this, "getTranslation", i18n.getTranslation);

    _defineProperty(this, "setLocale", i18n.setLocale);

    _defineProperty(this, "getLocale", i18n.getLocale);

    _defineProperty(this, "setDefaultLocale", i18n.setDefaultLocale);

    _defineProperty(this, "getDefaultLocale", i18n.getDefaultLocale);

    _defineProperty(this, "setFormats", i18n.setFormats);

    _defineProperty(this, "getFormats", i18n.getFormats);

    _defineProperty(this, "getRegisteredLocales", i18n.getRegisteredLocales);

    _defineProperty(this, "init", i18n.init);

    _defineProperty(this, "load", i18n.load);

    _defineProperty(this, "$get", () => i18n.translate);
  }

}

exports.I18nProvider = I18nProvider;