"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wizardSavedObjectType = void 0;

var _common = require("../../common");

/*
 * Copyright OpenSearch Contributors
 * SPDX-License-Identifier: Apache-2.0
 */
const wizardSavedObjectType = {
  name: _common.WIZARD_SAVED_OBJECT,
  hidden: false,
  namespaceType: 'single',
  management: {
    // icon: '', // TODO: Need a custom icon here - unfortunately a custom SVG won't work without changes to the SavedObjectsManagement plugin
    defaultSearchField: 'title',
    importableAndExportable: true,
    getTitle: ({
      attributes: {
        title
      }
    }) => title,
    getEditUrl: ({
      id
    }) => `/management/opensearch-dashboards/objects/savedWizard/${encodeURIComponent(id)}`,

    getInAppUrl({
      id
    }) {
      return {
        path: `/app/${_common.PLUGIN_ID}${_common.EDIT_PATH}/${encodeURIComponent(id)}`,
        uiCapabilitiesPath: 'wizard.show'
      };
    }

  },
  migrations: {},
  mappings: {
    properties: {
      title: {
        type: 'text'
      },
      description: {
        type: 'text'
      },
      visualizationState: {
        type: 'text',
        index: false
      },
      styleState: {
        type: 'text',
        index: false
      },
      version: {
        type: 'integer'
      }
    }
  }
};
exports.wizardSavedObjectType = wizardSavedObjectType;