/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.2
 * @date    2021-01-08T20:37:11.601Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
var t="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function e(t){var e={exports:{}};return t(e,e.exports),e.exports}var r=function(t){return t&&t.Math==Math&&t},n=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof t&&t)||function(){return this}()||Function("return this")(),i=function(t){try{return!!t()}catch(t){return!0}},o=!i((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),a={}.propertyIsEnumerable,u=Object.getOwnPropertyDescriptor,s={f:u&&!a.call({1:2},1)?function(t){var e=u(this,t);return!!e&&e.enumerable}:a},c=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},l={}.toString,f=function(t){return l.call(t).slice(8,-1)},h="".split,p=i((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==f(t)?h.call(t,""):Object(t)}:Object,v=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},d=function(t){return p(v(t))},y=function(t){return"object"==typeof t?null!==t:"function"==typeof t},g=function(t,e){if(!y(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!y(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!y(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!y(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},m={}.hasOwnProperty,b=function(t,e){return m.call(t,e)},_=n.document,w=y(_)&&y(_.createElement),E=function(t){return w?_.createElement(t):{}},O=!o&&!i((function(){return 7!=Object.defineProperty(E("div"),"a",{get:function(){return 7}}).a})),S=Object.getOwnPropertyDescriptor,T={f:o?S:function(t,e){if(t=d(t),e=g(e,!0),O)try{return S(t,e)}catch(t){}if(b(t,e))return c(!s.f.call(t,e),t[e])}},x=/#|\.prototype\./,k=function(t,e){var r=j[A(t)];return r==P||r!=I&&("function"==typeof e?i(e):!!e)},A=k.normalize=function(t){return String(t).replace(x,".").toLowerCase()},j=k.data={},I=k.NATIVE="N",P=k.POLYFILL="P",D=k,L={},C=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},R=function(t,e,r){if(C(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,i){return t.call(e,r,n,i)}}return function(){return t.apply(e,arguments)}},M=function(t){if(!y(t))throw TypeError(String(t)+" is not an object");return t},N=Object.defineProperty,F={f:o?N:function(t,e,r){if(M(t),e=g(e,!0),M(r),O)try{return N(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},z=o?function(t,e,r){return F.f(t,e,c(1,r))}:function(t,e,r){return t[e]=r,t},q=T.f,Y=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},U=function(t,e){var r,i,o,a,u,s,c,l,f=t.target,h=t.global,p=t.stat,v=t.proto,d=h?n:p?n[f]:(n[f]||{}).prototype,y=h?L:L[f]||(L[f]={}),g=y.prototype;for(o in e)r=!D(h?o:f+(p?".":"#")+o,t.forced)&&d&&b(d,o),u=y[o],r&&(s=t.noTargetGet?(l=q(d,o))&&l.value:d[o]),a=r&&s?s:e[o],r&&typeof u==typeof a||(c=t.bind&&r?R(a,n):t.wrap&&r?Y(a):v&&"function"==typeof a?R(Function.call,a):a,(t.sham||a&&a.sham||u&&u.sham)&&z(c,"sham",!0),y[o]=c,v&&(b(L,i=f+"Prototype")||z(L,i,{}),L[i][o]=a,t.real&&g&&!g[o]&&z(g,o,a)))},X=Array.isArray||function(t){return"Array"==f(t)},W=Math.ceil,G=Math.floor,V=function(t){return isNaN(t=+t)?0:(t>0?G:W)(t)},H=Math.min,$=function(t){return t>0?H(V(t),9007199254740991):0},J=function(t,e,r,n,i,o,a,u){for(var s,c=i,l=0,f=!!a&&R(a,u,3);l<n;){if(l in r){if(s=f?f(r[l],l,e):r[l],o>0&&X(s))c=J(t,e,s,$(s.length),c,o-1)-1;else{if(c>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[c]=s}c++}l++}return c},Q=J,B=function(t){return Object(v(t))},K=n["__core-js_shared__"]||function(t,e){try{z(n,t,e)}catch(r){n[t]=e}return e}("__core-js_shared__",{}),Z=e((function(t){(t.exports=function(t,e){return K[t]||(K[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.7.0",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),tt=0,et=Math.random(),rt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++tt+et).toString(36)},nt=!!Object.getOwnPropertySymbols&&!i((function(){return!String(Symbol())})),it=nt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,ot=Z("wks"),at=n.Symbol,ut=it?at:at&&at.withoutSetter||rt,st=function(t){return b(ot,t)||(nt&&b(at,t)?ot[t]=at[t]:ot[t]=ut("Symbol."+t)),ot[t]},ct=st("species"),lt=function(t,e){var r;return X(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!X(r.prototype)?y(r)&&null===(r=r[ct])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)};U({target:"Array",proto:!0},{flatMap:function(t){var e,r=B(this),n=$(r.length);return C(t),(e=lt(r,0)).length=Q(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var ft,ht,pt=function(t){return L[t+"Prototype"]},vt=pt("Array").flatMap,dt=Array.prototype,yt=function(t){var e=t.flatMap;return t===dt||t instanceof Array&&e===dt.flatMap?vt:e},gt=[].push,mt=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=5==t||o;return function(u,s,c,l){for(var f,h,v=B(u),d=p(v),y=R(s,c,3),g=$(d.length),m=0,b=l||lt,_=e?b(u,g):r?b(u,0):void 0;g>m;m++)if((a||m in d)&&(h=y(f=d[m],m,v),t))if(e)_[m]=h;else if(h)switch(t){case 3:return!0;case 5:return f;case 6:return m;case 2:gt.call(_,f)}else if(i)return!1;return o?-1:n||i?i:_}},bt={forEach:mt(0),map:mt(1),filter:mt(2),some:mt(3),every:mt(4),find:mt(5),findIndex:mt(6)},_t=function(t){return"function"==typeof t?t:void 0},wt=function(t,e){return arguments.length<2?_t(L[t])||_t(n[t]):L[t]&&L[t][e]||n[t]&&n[t][e]},Et=wt("navigator","userAgent")||"",Ot=n.process,St=Ot&&Ot.versions,Tt=St&&St.v8;Tt?ht=(ft=Tt.split("."))[0]+ft[1]:Et&&(!(ft=Et.match(/Edge\/(\d+)/))||ft[1]>=74)&&(ft=Et.match(/Chrome\/(\d+)/))&&(ht=ft[1]);var xt=ht&&+ht,kt=st("species"),At=function(t){return xt>=51||!i((function(){var e=[];return(e.constructor={})[kt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},jt=Object.defineProperty,It={},Pt=function(t){throw t},Dt=function(t,e){if(b(It,t))return It[t];e||(e={});var r=[][t],n=!!b(e,"ACCESSORS")&&e.ACCESSORS,a=b(e,0)?e[0]:Pt,u=b(e,1)?e[1]:void 0;return It[t]=!!r&&!i((function(){if(n&&!o)return!0;var t={length:-1};n?jt(t,1,{enumerable:!0,get:Pt}):t[1]=1,r.call(t,a,u)}))},Lt=bt.map,Ct=At("map"),Rt=Dt("map");U({target:"Array",proto:!0,forced:!Ct||!Rt},{map:function(t){return Lt(this,t,arguments.length>1?arguments[1]:void 0)}});var Mt=pt("Array").map,Nt=Array.prototype,Ft=function(t){var e=t.map;return t===Nt||t instanceof Array&&e===Nt.map?Mt:e},zt=bt.filter,qt=At("filter"),Yt=Dt("filter");U({target:"Array",proto:!0,forced:!qt||!Yt},{filter:function(t){return zt(this,t,arguments.length>1?arguments[1]:void 0)}});var Ut=pt("Array").filter,Xt=Array.prototype,Wt=function(t){var e=t.filter;return t===Xt||t instanceof Array&&e===Xt.filter?Ut:e},Gt=function(t){return function(e,r,n,i){C(r);var o=B(e),a=p(o),u=$(o.length),s=t?u-1:0,c=t?-1:1;if(n<2)for(;;){if(s in a){i=a[s],s+=c;break}if(s+=c,t?s<0:u<=s)throw TypeError("Reduce of empty array with no initial value")}for(;t?s>=0:u>s;s+=c)s in a&&(i=r(i,a[s],s,o));return i}},Vt={left:Gt(!1),right:Gt(!0)},Ht=function(t,e){var r=[][t];return!!r&&i((function(){r.call(null,e||function(){throw 1},1)}))},$t="process"==f(n.process),Jt=Vt.left,Qt=Ht("reduce"),Bt=Dt("reduce",{1:0});U({target:"Array",proto:!0,forced:!Qt||!Bt||!$t&&xt>79&&xt<83},{reduce:function(t){return Jt(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Kt=pt("Array").reduce,Zt=Array.prototype,te=function(t){var e=t.reduce;return t===Zt||t instanceof Array&&e===Zt.reduce?Kt:e},ee=[].slice,re={},ne=function(t,e,r){if(!(e in re)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";re[e]=Function("C,a","return new C("+n.join(",")+")")}return re[e](t,r)},ie=Function.bind||function(t){var e=C(this),r=ee.call(arguments,1),n=function(){var i=r.concat(ee.call(arguments));return this instanceof n?ne(e,i.length,i):e.apply(t,i)};return y(e.prototype)&&(n.prototype=e.prototype),n};U({target:"Function",proto:!0},{bind:ie});var oe=pt("Function").bind,ae=Function.prototype,ue=function(t){var e=t.bind;return t===ae||t instanceof Function&&e===ae.bind?oe:e};var se=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};U({target:"Object",stat:!0,forced:!o,sham:!o},{defineProperty:F.f});var ce=e((function(t){var e=L.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),le=ce;function fe(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),le(t,n.key,n)}}var he=function(t,e,r){return e&&fe(t.prototype,e),r&&fe(t,r),t};function pe(t){return new de(t)}var ve=function(){function t(e,r,n){var i,o,a;se(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:ue(i=this._add).call(i,this),remove:ue(o=this._remove).call(o,this),update:ue(a=this._update).call(a,this)}}return he(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return te(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),de=function(){function t(e){se(this,t),this._source=e,this._transformers=[]}return he(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Wt(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Ft(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return yt(e).call(e,t)})),this}},{key:"to",value:function(t){return new ve(this._source,this._transformers,t)}}]),t}(),ye=ce,ge=Math.max,me=Math.min,be=function(t,e){var r=V(t);return r<0?ge(r+e,0):me(r,e)},_e=function(t){return function(e,r,n){var i,o=d(e),a=$(o.length),u=be(n,a);if(t&&r!=r){for(;a>u;)if((i=o[u++])!=i)return!0}else for(;a>u;u++)if((t||u in o)&&o[u]===r)return t||u||0;return!t&&-1}},we={includes:_e(!0),indexOf:_e(!1)},Ee={},Oe=we.indexOf,Se=function(t,e){var r,n=d(t),i=0,o=[];for(r in n)!b(Ee,r)&&b(n,r)&&o.push(r);for(;e.length>i;)b(n,r=e[i++])&&(~Oe(o,r)||o.push(r));return o},Te=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],xe=Object.keys||function(t){return Se(t,Te)},ke=o?Object.defineProperties:function(t,e){M(t);for(var r,n=xe(e),i=n.length,o=0;i>o;)F.f(t,r=n[o++],e[r]);return t};U({target:"Object",stat:!0,forced:!o,sham:!o},{defineProperties:ke});var Ae=e((function(t){var e=L.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),je=Te.concat("length","prototype"),Ie={f:Object.getOwnPropertyNames||function(t){return Se(t,je)}},Pe={f:Object.getOwnPropertySymbols},De=wt("Reflect","ownKeys")||function(t){var e=Ie.f(M(t)),r=Pe.f;return r?e.concat(r(t)):e},Le=function(t,e,r){var n=g(e);n in t?F.f(t,n,c(0,r)):t[n]=r};U({target:"Object",stat:!0,sham:!o},{getOwnPropertyDescriptors:function(t){for(var e,r,n=d(t),i=T.f,o=De(n),a={},u=0;o.length>u;)void 0!==(r=i(n,e=o[u++]))&&Le(a,e,r);return a}});var Ce=L.Object.getOwnPropertyDescriptors,Re=T.f,Me=i((function(){Re(1)}));U({target:"Object",stat:!0,forced:!o||Me,sham:!o},{getOwnPropertyDescriptor:function(t,e){return Re(d(t),e)}});var Ne,Fe=e((function(t){var e=L.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),ze=wt("document","documentElement"),qe=Z("keys"),Ye=function(t){return qe[t]||(qe[t]=rt(t))},Ue=Ye("IE_PROTO"),Xe=function(){},We=function(t){return"<script>"+t+"<\/script>"},Ge=function(){try{Ne=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Ge=Ne?function(t){t.write(We("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Ne):((e=E("iframe")).style.display="none",ze.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(We("document.F=Object")),t.close(),t.F);for(var r=Te.length;r--;)delete Ge.prototype[Te[r]];return Ge()};Ee[Ue]=!0;var Ve=Object.create||function(t,e){var r;return null!==t?(Xe.prototype=M(t),r=new Xe,Xe.prototype=null,r[Ue]=t):r=Ge(),void 0===e?r:ke(r,e)},He=Ie.f,$e={}.toString,Je="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Qe={f:function(t){return Je&&"[object Window]"==$e.call(t)?function(t){try{return He(t)}catch(t){return Je.slice()}}(t):He(d(t))}},Be=function(t,e,r,n){n&&n.enumerable?t[e]=r:z(t,e,r)},Ke={f:st},Ze=F.f,tr=function(t){var e=L.Symbol||(L.Symbol={});b(e,t)||Ze(e,t,{value:Ke.f(t)})},er={};er[st("toStringTag")]="z";var rr="[object z]"===String(er),nr=st("toStringTag"),ir="Arguments"==f(function(){return arguments}()),or=rr?f:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),nr))?r:ir?f(e):"Object"==(n=f(e))&&"function"==typeof e.callee?"Arguments":n},ar=rr?{}.toString:function(){return"[object "+or(this)+"]"},ur=F.f,sr=st("toStringTag"),cr=function(t,e,r,n){if(t){var i=r?t:t.prototype;b(i,sr)||ur(i,sr,{configurable:!0,value:e}),n&&!rr&&z(i,"toString",ar)}},lr=Function.toString;"function"!=typeof K.inspectSource&&(K.inspectSource=function(t){return lr.call(t)});var fr,hr,pr,vr=K.inspectSource,dr=n.WeakMap,yr="function"==typeof dr&&/native code/.test(vr(dr)),gr=n.WeakMap;if(yr){var mr=K.state||(K.state=new gr),br=mr.get,_r=mr.has,wr=mr.set;fr=function(t,e){return e.facade=t,wr.call(mr,t,e),e},hr=function(t){return br.call(mr,t)||{}},pr=function(t){return _r.call(mr,t)}}else{var Er=Ye("state");Ee[Er]=!0,fr=function(t,e){return e.facade=t,z(t,Er,e),e},hr=function(t){return b(t,Er)?t[Er]:{}},pr=function(t){return b(t,Er)}}var Or={set:fr,get:hr,has:pr,enforce:function(t){return pr(t)?hr(t):fr(t,{})},getterFor:function(t){return function(e){var r;if(!y(e)||(r=hr(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},Sr=bt.forEach,Tr=Ye("hidden"),xr=st("toPrimitive"),kr=Or.set,Ar=Or.getterFor("Symbol"),jr=Object.prototype,Ir=n.Symbol,Pr=wt("JSON","stringify"),Dr=T.f,Lr=F.f,Cr=Qe.f,Rr=s.f,Mr=Z("symbols"),Nr=Z("op-symbols"),Fr=Z("string-to-symbol-registry"),zr=Z("symbol-to-string-registry"),qr=Z("wks"),Yr=n.QObject,Ur=!Yr||!Yr.prototype||!Yr.prototype.findChild,Xr=o&&i((function(){return 7!=Ve(Lr({},"a",{get:function(){return Lr(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Dr(jr,e);n&&delete jr[e],Lr(t,e,r),n&&t!==jr&&Lr(jr,e,n)}:Lr,Wr=function(t,e){var r=Mr[t]=Ve(Ir.prototype);return kr(r,{type:"Symbol",tag:t,description:e}),o||(r.description=e),r},Gr=it?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Ir},Vr=function(t,e,r){t===jr&&Vr(Nr,e,r),M(t);var n=g(e,!0);return M(r),b(Mr,n)?(r.enumerable?(b(t,Tr)&&t[Tr][n]&&(t[Tr][n]=!1),r=Ve(r,{enumerable:c(0,!1)})):(b(t,Tr)||Lr(t,Tr,c(1,{})),t[Tr][n]=!0),Xr(t,n,r)):Lr(t,n,r)},Hr=function(t,e){M(t);var r=d(e),n=xe(r).concat(Br(r));return Sr(n,(function(e){o&&!$r.call(r,e)||Vr(t,e,r[e])})),t},$r=function(t){var e=g(t,!0),r=Rr.call(this,e);return!(this===jr&&b(Mr,e)&&!b(Nr,e))&&(!(r||!b(this,e)||!b(Mr,e)||b(this,Tr)&&this[Tr][e])||r)},Jr=function(t,e){var r=d(t),n=g(e,!0);if(r!==jr||!b(Mr,n)||b(Nr,n)){var i=Dr(r,n);return!i||!b(Mr,n)||b(r,Tr)&&r[Tr][n]||(i.enumerable=!0),i}},Qr=function(t){var e=Cr(d(t)),r=[];return Sr(e,(function(t){b(Mr,t)||b(Ee,t)||r.push(t)})),r},Br=function(t){var e=t===jr,r=Cr(e?Nr:d(t)),n=[];return Sr(r,(function(t){!b(Mr,t)||e&&!b(jr,t)||n.push(Mr[t])})),n};if(nt||(Be((Ir=function(){if(this instanceof Ir)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=rt(t),r=function(t){this===jr&&r.call(Nr,t),b(this,Tr)&&b(this[Tr],e)&&(this[Tr][e]=!1),Xr(this,e,c(1,t))};return o&&Ur&&Xr(jr,e,{configurable:!0,set:r}),Wr(e,t)}).prototype,"toString",(function(){return Ar(this).tag})),Be(Ir,"withoutSetter",(function(t){return Wr(rt(t),t)})),s.f=$r,F.f=Vr,T.f=Jr,Ie.f=Qe.f=Qr,Pe.f=Br,Ke.f=function(t){return Wr(st(t),t)},o&&Lr(Ir.prototype,"description",{configurable:!0,get:function(){return Ar(this).description}})),U({global:!0,wrap:!0,forced:!nt,sham:!nt},{Symbol:Ir}),Sr(xe(qr),(function(t){tr(t)})),U({target:"Symbol",stat:!0,forced:!nt},{for:function(t){var e=String(t);if(b(Fr,e))return Fr[e];var r=Ir(e);return Fr[e]=r,zr[r]=e,r},keyFor:function(t){if(!Gr(t))throw TypeError(t+" is not a symbol");if(b(zr,t))return zr[t]},useSetter:function(){Ur=!0},useSimple:function(){Ur=!1}}),U({target:"Object",stat:!0,forced:!nt,sham:!o},{create:function(t,e){return void 0===e?Ve(t):Hr(Ve(t),e)},defineProperty:Vr,defineProperties:Hr,getOwnPropertyDescriptor:Jr}),U({target:"Object",stat:!0,forced:!nt},{getOwnPropertyNames:Qr,getOwnPropertySymbols:Br}),U({target:"Object",stat:!0,forced:i((function(){Pe.f(1)}))},{getOwnPropertySymbols:function(t){return Pe.f(B(t))}}),Pr){var Kr=!nt||i((function(){var t=Ir();return"[null]"!=Pr([t])||"{}"!=Pr({a:t})||"{}"!=Pr(Object(t))}));U({target:"JSON",stat:!0,forced:Kr},{stringify:function(t,e,r){for(var n,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(n=e,(y(e)||void 0!==t)&&!Gr(t))return X(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Gr(e))return e}),i[1]=e,Pr.apply(null,i)}})}Ir.prototype[xr]||z(Ir.prototype,xr,Ir.prototype.valueOf),cr(Ir,"Symbol"),Ee[Tr]=!0;var Zr,tn,en,rn=L.Object.getOwnPropertySymbols,nn={},on=!i((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),an=Ye("IE_PROTO"),un=Object.prototype,sn=on?Object.getPrototypeOf:function(t){return t=B(t),b(t,an)?t[an]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?un:null},cn=(st("iterator"),!1);[].keys&&("next"in(en=[].keys())?(tn=sn(sn(en)))!==Object.prototype&&(Zr=tn):cn=!0),null==Zr&&(Zr={});var ln={IteratorPrototype:Zr,BUGGY_SAFARI_ITERATORS:cn},fn=ln.IteratorPrototype,hn=function(){return this},pn=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return M(r),function(t){if(!y(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),vn=ln.IteratorPrototype,dn=ln.BUGGY_SAFARI_ITERATORS,yn=st("iterator"),gn=function(){return this},mn=function(t,e,r,n,i,o,a){!function(t,e,r){var n=e+" Iterator";t.prototype=Ve(fn,{next:c(1,r)}),cr(t,n,!1,!0),nn[n]=hn}(r,e,n);var u,s,l,f=function(t){if(t===i&&y)return y;if(!dn&&t in v)return v[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},h=e+" Iterator",p=!1,v=t.prototype,d=v[yn]||v["@@iterator"]||i&&v[i],y=!dn&&d||f(i),g="Array"==e&&v.entries||d;if(g&&(u=sn(g.call(new t)),vn!==Object.prototype&&u.next&&(cr(u,h,!0,!0),nn[h]=gn)),"values"==i&&d&&"values"!==d.name&&(p=!0,y=function(){return d.call(this)}),a&&v[yn]!==y&&z(v,yn,y),nn[e]=y,i)if(s={values:f("values"),keys:o?y:f("keys"),entries:f("entries")},a)for(l in s)(dn||p||!(l in v))&&Be(v,l,s[l]);else U({target:e,proto:!0,forced:dn||p},s);return s},bn=Or.set,_n=Or.getterFor("Array Iterator");mn(Array,"Array",(function(t,e){bn(this,{type:"Array Iterator",target:d(t),index:0,kind:e})}),(function(){var t=_n(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");nn.Arguments=nn.Array;var wn=st("toStringTag");for(var En in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var On=n[En],Sn=On&&On.prototype;Sn&&or(Sn)!==wn&&z(Sn,wn,En),nn[En]=nn.Array}var Tn=function(t){return function(e,r){var n,i,o=String(v(e)),a=V(r),u=o.length;return a<0||a>=u?t?"":void 0:(n=o.charCodeAt(a))<55296||n>56319||a+1===u||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):n:t?o.slice(a,a+2):i-56320+(n-55296<<10)+65536}},xn={codeAt:Tn(!1),charAt:Tn(!0)}.charAt,kn=Or.set,An=Or.getterFor("String Iterator");mn(String,"String",(function(t){kn(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=An(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=xn(r,n),e.index+=t.length,{value:t,done:!1})}));var jn=st("iterator"),In=function(t){if(null!=t)return t[jn]||t["@@iterator"]||nn[or(t)]},Pn=function(t){var e=In(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return M(e.call(t))},Dn=In,Ln=function(t){var e=t.return;if(void 0!==e)return M(e.call(t)).value},Cn=function(t,e,r,n){try{return n?e(M(r)[0],r[1]):e(r)}catch(e){throw Ln(t),e}},Rn=st("iterator"),Mn=Array.prototype,Nn=function(t){return void 0!==t&&(nn.Array===t||Mn[Rn]===t)},Fn=st("iterator"),zn=!1;try{var qn=0,Yn={next:function(){return{done:!!qn++}},return:function(){zn=!0}};Yn[Fn]=function(){return this},Array.from(Yn,(function(){throw 2}))}catch(t){}var Un=!function(t,e){if(!e&&!zn)return!1;var r=!1;try{var n={};n[Fn]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));U({target:"Array",stat:!0,forced:Un},{from:function(t){var e,r,n,i,o,a,u=B(t),s="function"==typeof this?this:Array,c=arguments.length,l=c>1?arguments[1]:void 0,f=void 0!==l,h=In(u),p=0;if(f&&(l=R(l,c>2?arguments[2]:void 0,2)),null==h||s==Array&&Nn(h))for(r=new s(e=$(u.length));e>p;p++)a=f?l(u[p],p):u[p],Le(r,p,a);else for(o=(i=h.call(u)).next,r=new s;!(n=o.call(i)).done;p++)a=f?Cn(i,l,[n.value,p],!0):n.value,Le(r,p,a);return r.length=p,r}});var Xn=L.Array.from,Wn=Xn;U({target:"Array",proto:!0},{fill:function(t){for(var e=B(this),r=$(e.length),n=arguments.length,i=be(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:be(o,r);a>i;)e[i++]=t;return e}});pt("Array").fill;var Gn=[].slice,Vn=/MSIE .\./.test(Et),Hn=function(t){return function(e,r){var n=arguments.length>2,i=n?Gn.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,r)}};U({global:!0,bind:!0,forced:Vn},{setTimeout:Hn(n.setTimeout),setInterval:Hn(n.setInterval)});var $n=L.setTimeout,Jn=wt("JSON","stringify"),Qn=/[\uD800-\uDFFF]/g,Bn=/^[\uD800-\uDBFF]$/,Kn=/^[\uDC00-\uDFFF]$/,Zn=function(t,e,r){var n=r.charAt(e-1),i=r.charAt(e+1);return Bn.test(t)&&!Kn.test(i)||Kn.test(t)&&!Bn.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},ti=i((function(){return'"\\udf06\\ud834"'!==Jn("\udf06\ud834")||'"\\udead"'!==Jn("\udead")}));Jn&&U({target:"JSON",stat:!0,forced:ti},{stringify:function(t,e,r){var n=Jn.apply(null,arguments);return"string"==typeof n?n.replace(Qn,Zn):n}}),L.JSON||(L.JSON={stringify:JSON.stringify});var ei=function(t,e,r){return L.JSON.stringify.apply(null,arguments)};U({target:"Object",stat:!0,sham:!o},{create:Ve});var ri=L.Object,ni=function(t,e){return ri.create(t,e)},ii=ni;var oi,ai=function(t,e,r){return e in t?le(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},ui="\t\n\v\f\r                　\u2028\u2029\ufeff",si="["+ui+"]",ci=RegExp("^"+si+si+"*"),li=RegExp(si+si+"*$"),fi=function(t){return function(e){var r=String(v(e));return 1&t&&(r=r.replace(ci,"")),2&t&&(r=r.replace(li,"")),r}},hi={start:fi(1),end:fi(2),trim:fi(3)},pi=hi.trim;U({target:"String",proto:!0,forced:(oi="trim",i((function(){return!!ui[oi]()||"​᠎"!="​᠎"[oi]()||ui[oi].name!==oi})))},{trim:function(){return pi(this)}});pt("String").trim;var vi=we.indexOf,di=[].indexOf,yi=!!di&&1/[1].indexOf(1,-0)<0,gi=Ht("indexOf"),mi=Dt("indexOf",{ACCESSORS:!0,1:0});U({target:"Array",proto:!0,forced:yi||!gi||!mi},{indexOf:function(t){return yi?di.apply(this,arguments)||0:vi(this,t,arguments.length>1?arguments[1]:void 0)}});pt("Array").indexOf;var bi=hi.trim,_i=n.parseInt,wi=/^[+-]?0[Xx]/,Ei=8!==_i(ui+"08")||22!==_i(ui+"0x16")?function(t,e){var r=bi(String(t));return _i(r,e>>>0||(wi.test(r)?16:10))}:_i;U({global:!0,forced:parseInt!=Ei},{parseInt:Ei});var Oi=s.f,Si=function(t){return function(e){for(var r,n=d(e),i=xe(n),a=i.length,u=0,s=[];a>u;)r=i[u++],o&&!Oi.call(n,r)||s.push(t?[r,n[r]]:n[r]);return s}},Ti={entries:Si(!0),values:Si(!1)}.values;U({target:"Object",stat:!0},{values:function(t){return Ti(t)}});L.Object.values;var xi=i((function(){sn(1)}));U({target:"Object",stat:!0,forced:xi,sham:!on},{getPrototypeOf:function(t){return sn(B(t))}});var ki=L.Object.getPrototypeOf,Ai=we.includes,ji=Dt("indexOf",{ACCESSORS:!0,1:0});U({target:"Array",proto:!0,forced:!ji},{includes:function(t){return Ai(this,t,arguments.length>1?arguments[1]:void 0)}});pt("Array").includes;var Ii=st("match"),Pi=function(t){if(function(t){var e;return y(t)&&(void 0!==(e=t[Ii])?!!e:"RegExp"==f(t))}(t))throw TypeError("The method doesn't accept regular expressions");return t},Di=st("match");U({target:"String",proto:!0,forced:!function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[Di]=!1,"/./"[t](e)}catch(t){}}return!1}("includes")},{includes:function(t){return!!~String(v(this)).indexOf(Pi(t),arguments.length>1?arguments[1]:void 0)}});pt("String").includes;var Li=Object.assign,Ci=Object.defineProperty,Ri=!Li||i((function(){if(o&&1!==Li({b:1},Li(Ci({},"a",{enumerable:!0,get:function(){Ci(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Li({},t)[r]||xe(Li({},e)).join("")!=n}))?function(t,e){for(var r=B(t),n=arguments.length,i=1,a=Pe.f,u=s.f;n>i;)for(var c,l=p(arguments[i++]),f=a?xe(l).concat(a(l)):xe(l),h=f.length,v=0;h>v;)c=f[v++],o&&!u.call(l,c)||(r[c]=l[c]);return r}:Li;U({target:"Object",stat:!0,forced:Object.assign!==Ri},{assign:Ri});var Mi=L.Object.assign,Ni=At("splice"),Fi=Dt("splice",{ACCESSORS:!0,0:0,1:2}),zi=Math.max,qi=Math.min;U({target:"Array",proto:!0,forced:!Ni||!Fi},{splice:function(t,e){var r,n,i,o,a,u,s=B(this),c=$(s.length),l=be(t,c),f=arguments.length;if(0===f?r=n=0:1===f?(r=0,n=c-l):(r=f-2,n=qi(zi(V(e),0),c-l)),c+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(i=lt(s,n),o=0;o<n;o++)(a=l+o)in s&&Le(i,o,s[a]);if(i.length=n,r<n){for(o=l;o<c-n;o++)u=o+r,(a=o+n)in s?s[u]=s[a]:delete s[u];for(o=c;o>c-n+r;o--)delete s[o-1]}else if(r>n)for(o=c-n;o>l;o--)u=o+r-1,(a=o+n-1)in s?s[u]=s[a]:delete s[u];for(o=0;o<r;o++)s[o+l]=arguments[o+2];return s.length=c-n+r,i}});var Yi=pt("Array").splice,Ui=Array.prototype,Xi=function(t){var e=t.splice;return t===Ui||t instanceof Array&&e===Ui.splice?Yi:e},Wi=[].reverse,Gi=[1,2];U({target:"Array",proto:!0,forced:String(Gi)===String(Gi.reverse())},{reverse:function(){return X(this)&&(this.length=this.length),Wi.call(this)}});var Vi=pt("Array").reverse,Hi=Array.prototype,$i=function(t){var e=t.reverse;return t===Hi||t instanceof Array&&e===Hi.reverse?Vi:e},Ji=bt.forEach,Qi=Ht("forEach"),Bi=Dt("forEach"),Ki=Qi&&Bi?[].forEach:function(t){return Ji(this,t,arguments.length>1?arguments[1]:void 0)};U({target:"Array",proto:!0,forced:[].forEach!=Ki},{forEach:Ki});var Zi=pt("Array").forEach,to=Array.prototype,eo={DOMTokenList:!0,NodeList:!0},ro=function(t){var e=t.forEach;return t===to||t instanceof Array&&e===to.forEach||eo.hasOwnProperty(or(t))?Zi:e};U({target:"Array",stat:!0},{isArray:X});var no=L.Array.isArray,io=no;var oo=function(t){if(io(t))return t},ao=st("iterator"),uo=function(t){var e=Object(t);return void 0!==e[ao]||"@@iterator"in e||nn.hasOwnProperty(or(e))},so=st("isConcatSpreadable"),co=xt>=51||!i((function(){var t=[];return t[so]=!1,t.concat()[0]!==t})),lo=At("concat"),fo=function(t){if(!y(t))return!1;var e=t[so];return void 0!==e?!!e:X(t)};U({target:"Array",proto:!0,forced:!co||!lo},{concat:function(t){var e,r,n,i,o,a=B(this),u=lt(a,0),s=0;for(e=-1,n=arguments.length;e<n;e++)if(fo(o=-1===e?a:arguments[e])){if(s+(i=$(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<i;r++,s++)r in o&&Le(u,s,o[r])}else{if(s>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Le(u,s++,o)}return u.length=s,u}}),tr("asyncIterator"),tr("hasInstance"),tr("isConcatSpreadable"),tr("iterator"),tr("match"),tr("matchAll"),tr("replace"),tr("search"),tr("species"),tr("split"),tr("toPrimitive"),tr("toStringTag"),tr("unscopables"),cr(n.JSON,"JSON",!0);var ho=L.Symbol;tr("asyncDispose"),tr("dispose"),tr("observable"),tr("patternMatch"),tr("replaceAll");var po=ho;var vo=function(t,e){if(void 0!==po&&uo(Object(t))){var r=[],n=!0,i=!1,o=void 0;try{for(var a,u=Pn(t);!(n=(a=u.next()).done)&&(r.push(a.value),!e||r.length!==e);n=!0);}catch(t){i=!0,o=t}finally{try{n||null==u.return||u.return()}finally{if(i)throw o}}return r}},yo=Xn,go=At("slice"),mo=Dt("slice",{ACCESSORS:!0,0:0,1:2}),bo=st("species"),_o=[].slice,wo=Math.max;U({target:"Array",proto:!0,forced:!go||!mo},{slice:function(t,e){var r,n,i,o=d(this),a=$(o.length),u=be(t,a),s=be(void 0===e?a:e,a);if(X(o)&&("function"!=typeof(r=o.constructor)||r!==Array&&!X(r.prototype)?y(r)&&null===(r=r[bo])&&(r=void 0):r=void 0,r===Array||void 0===r))return _o.call(o,u,s);for(n=new(void 0===r?Array:r)(wo(s-u,0)),i=0;u<s;u++,i++)u in o&&Le(n,i,o[u]);return n.length=i,n}});var Eo=pt("Array").slice,Oo=Array.prototype,So=function(t){var e=t.slice;return t===Oo||t instanceof Array&&e===Oo.slice?Eo:e},To=So;var xo=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var ko=function(t,e){var r;if(t){if("string"==typeof t)return xo(t,e);var n=To(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?yo(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?xo(t,e):void 0}};var Ao=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var jo=function(t,e){return oo(t)||vo(t,e)||ko(t,e)||Ao()};U({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});L.Date.now;var Io=i((function(){xe(1)}));U({target:"Object",stat:!0,forced:Io},{keys:function(t){return xe(B(t))}});var Po=L.Object.keys,Do=no,Lo=Ke.f("iterator"),Co=Lo,Ro=e((function(t){function e(r){return t.exports=e="function"==typeof po&&"symbol"==typeof Co?function(t){return typeof t}:function(t){return t&&"function"==typeof po&&t.constructor===po&&t!==po.prototype?"symbol":typeof t},e(r)}t.exports=e}));U({target:"Reflect",stat:!0},{ownKeys:De});var Mo=L.Reflect.ownKeys,No=So;var Fo=function(t){if(io(t))return xo(t)};var zo=function(t){if(void 0!==po&&uo(Object(t)))return yo(t)};var qo=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Yo=function(t){return Fo(t)||zo(t)||ko(t)||qo()},Uo=pt("Array").concat,Xo=Array.prototype,Wo=function(t){var e=t.concat;return t===Xo||t instanceof Array&&e===Xo.concat?Uo:e},Go=ho,Vo=e((function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */
function Ho(){return(Ho=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t}).apply(this,arguments)}function $o(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function Jo(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Qo,Bo="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign,Ko=["","webkit","Moz","MS","ms","o"],Zo="undefined"==typeof document?{style:{}}:document.createElement("div"),ta=Math.round,ea=Math.abs,ra=Date.now;function na(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<Ko.length;){if((n=(r=Ko[o])?r+i:e)in t)return n;o++}}Qo="undefined"==typeof window?{}:window;var ia=na(Zo.style,"touchAction"),oa=void 0!==ia;var aa=function(){if(!oa)return!1;var t={},e=Qo.CSS&&Qo.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||Qo.CSS.supports("touch-action",r)})),t}(),ua="ontouchstart"in Qo,sa=void 0!==na(Qo,"PointerEvent"),ca=ua&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),la=["x","y"],fa=["clientX","clientY"];function ha(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function pa(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function va(t,e){return t.indexOf(e)>-1}var da=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){"compute"===t&&(t=this.compute()),oa&&this.manager.element.style&&aa[t]&&(this.manager.element.style[ia]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return ha(this.manager.recognizers,(function(e){pa(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(va(t,"none"))return"none";var e=va(t,"pan-x"),r=va(t,"pan-y");return e&&r?"none":e||r?e?"pan-x":"pan-y":va(t,"manipulation")?"manipulation":"auto"}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=va(n,"none")&&!aa.none,o=va(n,"pan-y")&&!aa["pan-y"],a=va(n,"pan-x")&&!aa["pan-x"];if(i){var u=1===t.pointers.length,s=t.distance<2,c=t.deltaTime<250;if(u&&s&&c)return}if(!a||!o)return i||o&&6&r||a&&24&r?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function ya(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function ga(t){var e=t.length;if(1===e)return{x:ta(t[0].clientX),y:ta(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:ta(r/e),y:ta(n/e)}}function ma(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:ta(t.pointers[r].clientX),clientY:ta(t.pointers[r].clientY)},r++;return{timeStamp:ra(),pointers:e,center:ga(e),deltaX:t.deltaX,deltaY:t.deltaY}}function ba(t,e,r){r||(r=la);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function _a(t,e,r){r||(r=la);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function wa(t,e){return t===e?1:ea(t)>=ea(e)?t<0?2:4:e<0?8:16}function Ea(t,e,r){return{x:e/t||0,y:r/t||0}}function Oa(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=ma(e)),i>1&&!r.firstMultiple?r.firstMultiple=ma(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,u=a?a.center:o.center,s=e.center=ga(n);e.timeStamp=ra(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=_a(u,s),e.distance=ba(u,s),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};1!==e.eventType&&4!==o.eventType||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=wa(e.deltaX,e.deltaY);var c,l,f=Ea(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=f.x,e.overallVelocityY=f.y,e.overallVelocity=ea(f.x)>ea(f.y)?f.x:f.y,e.scale=a?(c=a.pointers,ba((l=n)[0],l[1],fa)/ba(c[0],c[1],fa)):1,e.rotation=a?function(t,e){return _a(e[1],e[0],fa)+_a(t[1],t[0],fa)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,u=e.timeStamp-a.timeStamp;if(8!==e.eventType&&(u>25||void 0===a.velocity)){var s=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,l=Ea(u,s,c);n=l.x,i=l.y,r=ea(l.x)>ea(l.y)?l.x:l.y,o=wa(s,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var h,p=t.element,v=e.srcEvent;ya(h=v.composedPath?v.composedPath()[0]:v.path?v.path[0]:v.target,p)&&(p=h),e.target=p}function Sa(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=1&e&&n-i==0,a=12&e&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Oa(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Ta(t){return t.trim().split(/\s+/g)}function xa(t,e,r){ha(Ta(e),(function(e){t.addEventListener(e,r,!1)}))}function ka(t,e,r){ha(Ta(e),(function(e){t.removeEventListener(e,r,!1)}))}function Aa(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var ja=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){pa(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&xa(this.element,this.evEl,this.domHandler),this.evTarget&&xa(this.target,this.evTarget,this.domHandler),this.evWin&&xa(Aa(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&ka(this.element,this.evEl,this.domHandler),this.evTarget&&ka(this.target,this.evTarget,this.domHandler),this.evWin&&ka(Aa(this.element),this.evWin,this.domHandler)},t}();function Ia(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var Pa={pointerdown:1,pointermove:2,pointerup:4,pointercancel:8,pointerout:8},Da={2:"touch",3:"pen",4:"mouse",5:"kinect"},La="pointerdown",Ca="pointermove pointerup pointercancel";Qo.MSPointerEvent&&!Qo.PointerEvent&&(La="MSPointerDown",Ca="MSPointerMove MSPointerUp MSPointerCancel");var Ra=function(t){function e(){var r,n=e.prototype;return n.evEl=La,n.evWin=Ca,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return $o(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=Pa[n],o=Da[t.pointerType]||t.pointerType,a="touch"===o,u=Ia(e,t.pointerId,"pointerId");1&i&&(0===t.button||a)?u<0&&(e.push(t),u=e.length-1):12&i&&(r=!0),u<0||(e[u]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(u,1))},e}(ja);function Ma(t){return Array.prototype.slice.call(t,0)}function Na(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];Ia(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Fa={touchstart:1,touchmove:2,touchend:4,touchcancel:8},za=function(t){function e(){var r;return e.prototype.evTarget="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).targetIds={},r}return $o(e,t),e.prototype.handler=function(t){var e=Fa[t.type],r=qa.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:"touch",srcEvent:t})},e}(ja);function qa(t,e){var r,n,i=Ma(t.touches),o=this.targetIds;if(3&e&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=Ma(t.changedTouches),u=[],s=this.target;if(n=i.filter((function(t){return ya(t.target,s)})),1===e)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&u.push(a[r]),12&e&&delete o[a[r].identifier],r++;return u.length?[Na(n.concat(u),"identifier",!0),u]:void 0}var Ya={mousedown:1,mousemove:2,mouseup:4},Ua=function(t){function e(){var r,n=e.prototype;return n.evEl="mousedown",n.evWin="mousemove mouseup",(r=t.apply(this,arguments)||this).pressed=!1,r}return $o(e,t),e.prototype.handler=function(t){var e=Ya[t.type];1&e&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=4),this.pressed&&(4&e&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:"mouse",srcEvent:t}))},e}(ja);function Xa(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),2500)}}function Wa(t,e){1&t?(this.primaryTouch=e.changedPointers[0].identifier,Xa.call(this,e)):12&t&&Xa.call(this,e)}function Ga(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=25&&a<=25)return!0}return!1}var Va=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i="touch"===r.pointerType,o="mouse"===r.pointerType;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)Wa.call(Jo(Jo(n)),e,r);else if(o&&Ga.call(Jo(Jo(n)),r))return;n.callback(t,e,r)}},n.touch=new za(n.manager,n.handler),n.mouse=new Ua(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return $o(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(ja)}();function Ha(t,e,r){return!!Array.isArray(t)&&(ha(t,r[e],r),!0)}var $a=1;function Ja(t,e){var r=e.manager;return r?r.get(t):t}function Qa(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var Ba=function(){function t(t){void 0===t&&(t={}),this.options=Ho({enable:!0},t),this.id=$a++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return Bo(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Ha(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Ja(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Ha(t,"dropRecognizeWith",this)||(t=Ja(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Ha(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Ia(e,t=Ja(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Ha(t,"dropRequireFailure",this))return this;t=Ja(t,this);var e=Ia(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<8&&n(e.options.event+Qa(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=8&&n(e.options.event+Qa(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=32},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=Bo({},t);if(!pa(this.options.enable,[this,e]))return this.reset(),void(this.state=32);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Ka=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ho({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}$o(e,t);var r=e.prototype;return r.getTouchAction=function(){return["manipulation"]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),1&t.eventType&&0===this.count)return this.failTimeout();if(i&&o&&n){if(4!==t.eventType)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,u=!this.pCenter||ba(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,u&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.interval),2):8}return 32},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=32}),this.options.interval),32},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Ba),Za=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ho({pointers:1},e))||this}$o(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=6&e,i=this.attrTest(t);return n&&(8&r||!i)?16|e:n||i?4&r?8|e:2&e?4|e:2:32},e}(Ba);function tu(t){return 16===t?"down":8===t?"up":2===t?"left":4===t?"right":""}var eu=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ho({event:"pan",threshold:10,pointers:1,direction:30},e))||this).pX=null,r.pY=null,r}$o(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return 6&t&&e.push("pan-y"),24&t&&e.push("pan-x"),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(6&e.direction?(i=0===o?1:o<0?2:4,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?1:a<0?8:16,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return Za.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=tu(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(Za),ru=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ho({event:"swipe",threshold:10,velocity:.3,direction:30,pointers:1},e))||this}$o(e,t);var r=e.prototype;return r.getTouchAction=function(){return eu.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return 30&n?r=e.overallVelocity:6&n?r=e.overallVelocityX:24&n&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&ea(r)>this.options.velocity&&4&e.eventType},r.emit=function(t){var e=tu(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Za),nu=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ho({event:"pinch",threshold:0,pointers:2},e))||this}$o(e,t);var r=e.prototype;return r.getTouchAction=function(){return["none"]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(Za),iu=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ho({event:"rotate",threshold:0,pointers:2},e))||this}$o(e,t);var r=e.prototype;return r.getTouchAction=function(){return["none"]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(Za),ou=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ho({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}$o(e,t);var r=e.prototype;return r.getTouchAction=function(){return["auto"]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||12&t.eventType&&!o)this.reset();else if(1&t.eventType)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.time);else if(4&t.eventType)return 8;return 32},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){8===this.state&&(t&&4&t.eventType?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=ra(),this.manager.emit(this.options.event,this._input)))},e}(Ba),au={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},uu=[[iu,{enable:!1}],[nu,{enable:!1},["rotate"]],[ru,{direction:6}],[eu,{direction:6},["swipe"]],[Ka],[Ka,{event:"doubletap",taps:2},["tap"]],[ou]];function su(t,e){var r,n=t.element;n.style&&(ha(t.options.cssProps,(function(i,o){r=na(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var cu=function(){function t(t,e){var r,n=this;this.options=Bo({},au,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(sa?Ra:ca?za:ua?Va:Ua))(r,Sa),this.touchAction=new da(this,this.options.touchAction),su(this,!0),ha(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return Bo(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&8&i.state)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&14&r.state&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof Ba)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(Ha(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Ha(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Ia(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return ha(Ta(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return ha(Ta(t),(function(t){e?r[t]&&r[t].splice(Ia(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&su(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),lu={touchstart:1,touchmove:2,touchend:4,touchcancel:8},fu=function(t){function e(){var r,n=e.prototype;return n.evTarget="touchstart",n.evWin="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).started=!1,r}return $o(e,t),e.prototype.handler=function(t){var e=lu[t.type];if(1===e&&(this.started=!0),this.started){var r=hu.call(this,t,e);12&e&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:"touch",srcEvent:t})}},e}(ja);function hu(t,e){var r=Ma(t.touches),n=Ma(t.changedTouches);return 12&e&&(r=Na(r.concat(n),"identifier",!0)),[r,n]}function pu(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var vu=pu((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),du=pu((function(t,e){return vu(t,e,!0)}),"merge","Use `assign`.");function yu(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&Bo(n,r)}function gu(t,e){return function(){return t.apply(e,arguments)}}var mu=function(){var t=function(t,e){return void 0===e&&(e={}),new cu(t,Ho({recognizers:uu.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=30,t.DIRECTION_DOWN=16,t.DIRECTION_LEFT=2,t.DIRECTION_RIGHT=4,t.DIRECTION_UP=8,t.DIRECTION_HORIZONTAL=6,t.DIRECTION_VERTICAL=24,t.DIRECTION_NONE=1,t.DIRECTION_DOWN=16,t.INPUT_START=1,t.INPUT_MOVE=2,t.INPUT_END=4,t.INPUT_CANCEL=8,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=32,t.Manager=cu,t.Input=ja,t.TouchAction=da,t.TouchInput=za,t.MouseInput=Ua,t.PointerEventInput=Ra,t.TouchMouseInput=Va,t.SingleTouchInput=fu,t.Recognizer=Ba,t.AttrRecognizer=Za,t.Tap=Ka,t.Pan=eu,t.Swipe=ru,t.Pinch=nu,t.Rotate=iu,t.Press=ou,t.on=xa,t.off=ka,t.each=ha,t.merge=du,t.extend=vu,t.bindFn=gu,t.assign=Bo,t.inherit=yu,t.bindFn=gu,t.prefixed=na,t.toArray=Ma,t.inArray=Ia,t.uniqueArray=Na,t.splitStr=Ta,t.boolOrFn=pa,t.hasParent=ya,t.addEventListeners=xa,t.removeEventListeners=ka,t.defaults=Bo({},au,{preset:uu}),t}();function bu(t,e){var r;if(void 0===Go||null==Dn(t)){if(Do(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return _u(t,e);var n=No(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Wn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _u(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=Pn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function _u(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var wu=Go("DELETE");function Eu(){var t=Ou.apply(void 0,arguments);return Tu(t),t}function Ou(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Ou.apply(void 0,Wo(n=[Eu(e[0],e[1])]).call(n,Yo(No(e).call(e,2))));var i,o=e[0],a=e[1],u=bu(Mo(a));try{for(u.s();!(i=u.n()).done;){var s=i.value;Object.prototype.propertyIsEnumerable.call(a,s)&&(a[s]===wu?delete o[s]:null===o[s]||null===a[s]||"object"!==Ro(o[s])||"object"!==Ro(a[s])||Do(o[s])||Do(a[s])?o[s]=Su(a[s]):o[s]=Ou(o[s],a[s]))}}catch(t){u.e(t)}finally{u.f()}return o}function Su(t){return Do(t)?Ft(t).call(t,(function(t){return Su(t)})):"object"===Ro(t)&&null!==t?Ou({},t):t}function Tu(t){for(var e=0,r=Po(t);e<r.length;e++){var n=r[e];t[n]===wu?delete t[n]:"object"===Ro(t[n])&&null!==t[n]&&Tu(t[n])}}var xu="undefined"!=typeof window?window.Hammer||mu:function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(){return{set:t}}};var t};function ku(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=xu(this._dom.overlay);n.on("tap",ue(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];ro(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Vo(ku.prototype),ku.current=null,ku.prototype.destroy=function(){var t,e;this.deactivate();var r,n=bu($i(t=Xi(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},ku.prototype.activate=function(){ku.current&&ku.current.deactivate(),ku.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},ku.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},ku.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Au=wt("Reflect","construct"),ju=i((function(){function t(){}return!(Au((function(){}),[],t)instanceof t)})),Iu=!i((function(){Au((function(){}))})),Pu=ju||Iu;U({target:"Reflect",stat:!0,forced:Pu,sham:Pu},{construct:function(t,e){C(t),M(e);var r=arguments.length<3?t:C(arguments[2]);if(Iu&&!ju)return Au(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(ie.apply(t,n))}var i=r.prototype,o=Ve(y(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return y(a)?a:o}});var Du=L.Reflect.construct,Lu=pt("Array").entries,Cu=Array.prototype,Ru={DOMTokenList:!0,NodeList:!0},Mu=function(t){var e=t.entries;return t===Cu||t instanceof Array&&e===Cu.entries||Ru.hasOwnProperty(or(t))?Lu:e},Nu=e((function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,i="function"==typeof Symbol?Symbol:{},o=i.iterator||"@@iterator",a=i.asyncIterator||"@@asyncIterator",u=i.toStringTag||"@@toStringTag";function s(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{s({},"")}catch(t){s=function(t,e,r){return t[e]=r}}function c(t,e,r,n){var i=e&&e.prototype instanceof y?e:y,o=Object.create(i.prototype),a=new A(n||[]);return o._invoke=function(t,e,r){var n=f;return function(i,o){if(n===p)throw new Error("Generator is already running");if(n===v){if("throw"===i)throw o;return I()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var u=T(a,r);if(u){if(u===d)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===f)throw n=v,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=p;var s=l(t,e,r);if("normal"===s.type){if(n=r.done?v:h,s.arg===d)continue;return{value:s.arg,done:r.done}}"throw"===s.type&&(n=v,r.method="throw",r.arg=s.arg)}}}(t,r,a),o}function l(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=c;var f="suspendedStart",h="suspendedYield",p="executing",v="completed",d={};function y(){}function g(){}function m(){}var b={};b[o]=function(){return this};var _=Object.getPrototypeOf,w=_&&_(_(j([])));w&&w!==r&&n.call(w,o)&&(b=w);var E=m.prototype=y.prototype=Object.create(b);function O(t){["next","throw","return"].forEach((function(e){s(t,e,(function(t){return this._invoke(e,t)}))}))}function S(t,e){function r(i,o,a,u){var s=l(t[i],t,o);if("throw"!==s.type){var c=s.arg,f=c.value;return f&&"object"==typeof f&&n.call(f,"__await")?e.resolve(f.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(f).then((function(t){c.value=t,a(c)}),(function(t){return r("throw",t,a,u)}))}u(s.arg)}var i;this._invoke=function(t,n){function o(){return new e((function(e,i){r(t,n,e,i)}))}return i=i?i.then(o,o):o()}}function T(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,T(t,r),"throw"===r.method))return d;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return d}var i=l(n,t.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,d;var o=i.arg;return o?o.done?(r[t.resultName]=o.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,d):o:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,d)}function x(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function k(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function A(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(x,this),this.reset(!0)}function j(t){if(t){var r=t[o];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,a=function r(){for(;++i<t.length;)if(n.call(t,i))return r.value=t[i],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:I}}function I(){return{value:e,done:!0}}return g.prototype=E.constructor=m,m.constructor=g,g.displayName=s(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,s(t,u,"GeneratorFunction")),t.prototype=Object.create(E),t},t.awrap=function(t){return{__await:t}},O(S.prototype),S.prototype[a]=function(){return this},t.AsyncIterator=S,t.async=function(e,r,n,i,o){void 0===o&&(o=Promise);var a=new S(c(e,r,n,i),o);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},O(E),s(E,u,"Generator"),E[o]=function(){return this},E.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=j,A.prototype={constructor:A,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(k),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function i(n,i){return u.type="throw",u.arg=t,r.next=n,i&&(r.method="next",r.arg=e),!!i}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],u=a.completion;if("root"===a.tryLoc)return i("end");if(a.tryLoc<=this.prev){var s=n.call(a,"catchLoc"),c=n.call(a,"finallyLoc");if(s&&c){if(this.prev<a.catchLoc)return i(a.catchLoc,!0);if(this.prev<a.finallyLoc)return i(a.finallyLoc)}else if(s){if(this.prev<a.catchLoc)return i(a.catchLoc,!0)}else{if(!c)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return i(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,d):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),d},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),k(r),d}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;k(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:j(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),d}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),Fu=Lo,zu=pt("Array").values,qu=Array.prototype,Yu={DOMTokenList:!0,NodeList:!0},Uu=function(t){var e=t.values;return t===qu||t instanceof Array&&e===qu.values||Yu.hasOwnProperty(or(t))?zu:e},Xu=[],Wu=Xu.sort,Gu=i((function(){Xu.sort(void 0)})),Vu=i((function(){Xu.sort(null)})),Hu=Ht("sort");U({target:"Array",proto:!0,forced:Gu||!Vu||!Hu},{sort:function(t){return void 0===t?Wu.call(B(this)):Wu.call(B(this),C(t))}});var $u=pt("Array").sort,Ju=Array.prototype,Qu=function(t){var e=t.sort;return t===Ju||t instanceof Array&&e===Ju.sort?$u:e},Bu=pt("Array").keys,Ku=Array.prototype,Zu={DOMTokenList:!0,NodeList:!0},ts=function(t){var e=t.keys;return t===Ku||t instanceof Array&&e===Ku.keys||Zu.hasOwnProperty(or(t))?Bu:e},es=bt.some,rs=Ht("some"),ns=Dt("some");U({target:"Array",proto:!0,forced:!rs||!ns},{some:function(t){return es(this,t,arguments.length>1?arguments[1]:void 0)}});var is=pt("Array").some,os=Array.prototype,as=function(t){var e=t.some;return t===os||t instanceof Array&&e===os.some?is:e},us=!i((function(){return Object.isExtensible(Object.preventExtensions({}))})),ss=e((function(t){var e=F.f,r=rt("meta"),n=0,i=Object.isExtensible||function(){return!0},o=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!y(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!b(t,r)){if(!i(t))return"F";if(!e)return"E";o(t)}return t[r].objectID},getWeakData:function(t,e){if(!b(t,r)){if(!i(t))return!0;if(!e)return!1;o(t)}return t[r].weakData},onFreeze:function(t){return us&&a.REQUIRED&&i(t)&&!b(t,r)&&o(t),t}};Ee[r]=!0})),cs=function(t,e){this.stopped=t,this.result=e},ls=function(t,e,r){var n,i,o,a,u,s,c,l=r&&r.that,f=!(!r||!r.AS_ENTRIES),h=!(!r||!r.IS_ITERATOR),p=!(!r||!r.INTERRUPTED),v=R(e,l,1+f+p),d=function(t){return n&&Ln(n),new cs(!0,t)},y=function(t){return f?(M(t),p?v(t[0],t[1],d):v(t[0],t[1])):p?v(t,d):v(t)};if(h)n=t;else{if("function"!=typeof(i=In(t)))throw TypeError("Target is not iterable");if(Nn(i)){for(o=0,a=$(t.length);a>o;o++)if((u=y(t[o]))&&u instanceof cs)return u;return new cs(!1)}n=i.call(t)}for(s=n.next;!(c=s.call(n)).done;){try{u=y(c.value)}catch(t){throw Ln(n),t}if("object"==typeof u&&u&&u instanceof cs)return u}return new cs(!1)},fs=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},hs=F.f,ps=bt.forEach,vs=Or.set,ds=Or.getterFor,ys=function(t,e,r){var a,u=-1!==t.indexOf("Map"),s=-1!==t.indexOf("Weak"),c=u?"set":"add",l=n[t],f=l&&l.prototype,h={};if(o&&"function"==typeof l&&(s||f.forEach&&!i((function(){(new l).entries().next()})))){a=e((function(e,r){vs(fs(e,a,t),{type:t,collection:new l}),null!=r&&ls(r,e[c],{that:e,AS_ENTRIES:u})}));var p=ds(t);ps(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in f)||s&&"clear"==t||z(a.prototype,t,(function(r,n){var i=p(this).collection;if(!e&&s&&!y(r))return"get"==t&&void 0;var o=i[t](0===r?0:r,n);return e?this:o}))})),s||hs(a.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else a=r.getConstructor(e,t,u,c),ss.REQUIRED=!0;return cr(a,t,!1,!0),h[t]=a,U({global:!0,forced:!0},h),s||r.setStrong(a,t,u),a},gs=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:Be(t,n,e[n],r);return t},ms=st("species"),bs=F.f,_s=ss.fastKey,ws=Or.set,Es=Or.getterFor,Os={getConstructor:function(t,e,r,n){var i=t((function(t,a){fs(t,i,e),ws(t,{type:e,index:Ve(null),first:void 0,last:void 0,size:0}),o||(t.size=0),null!=a&&ls(a,t[n],{that:t,AS_ENTRIES:r})})),a=Es(e),u=function(t,e,r){var n,i,u=a(t),c=s(t,e);return c?c.value=r:(u.last=c={index:i=_s(e,!0),key:e,value:r,previous:n=u.last,next:void 0,removed:!1},u.first||(u.first=c),n&&(n.next=c),o?u.size++:t.size++,"F"!==i&&(u.index[i]=c)),t},s=function(t,e){var r,n=a(t),i=_s(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return gs(i.prototype,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,o?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=s(e,t);if(n){var i=n.next,u=n.previous;delete r.index[n.index],n.removed=!0,u&&(u.next=i),i&&(i.previous=u),r.first==n&&(r.first=i),r.last==n&&(r.last=u),o?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=R(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),gs(i.prototype,r?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),o&&bs(i.prototype,"size",{get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=Es(e),a=Es(n);mn(t,e,(function(t,e){ws(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=a(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=wt(t),r=F.f;o&&e&&!e[ms]&&r(e,ms,{configurable:!0,get:function(){return this}})}(e)}},Ss=(ys("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Os),L.Map),Ts=ni;U({target:"Object",stat:!0},{setPrototypeOf:pn});var xs=L.Object.setPrototypeOf,ks=e((function(t){function e(r,n){return t.exports=e=xs||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var As=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Ts(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&ks(t,e)};var js=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var Is,Ps=function(t,e){return!e||"object"!==Ro(e)&&"function"!=typeof e?js(t):e},Ds=ki,Ls=e((function(t){function e(r){return t.exports=e=xs?Ds:function(t){return t.__proto__||Ds(t)},e(r)}t.exports=e})),Cs=new Uint8Array(16);function Rs(){if(!Is&&!(Is="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Is(Cs)}var Ms=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function Ns(t){return"string"==typeof t&&Ms.test(t)}for(var Fs=[],zs=0;zs<256;++zs)Fs.push((zs+256).toString(16).substr(1));function qs(t,e,r){var n=(t=t||{}).random||(t.rng||Rs)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Fs[t[e+0]]+Fs[t[e+1]]+Fs[t[e+2]]+Fs[t[e+3]]+"-"+Fs[t[e+4]]+Fs[t[e+5]]+"-"+Fs[t[e+6]]+Fs[t[e+7]]+"-"+Fs[t[e+8]]+Fs[t[e+9]]+"-"+Fs[t[e+10]]+Fs[t[e+11]]+Fs[t[e+12]]+Fs[t[e+13]]+Fs[t[e+14]]+Fs[t[e+15]]).toLowerCase();if(!Ns(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function Ys(t){return"string"==typeof t||"number"==typeof t}var Us=function(){function t(e){se(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return he(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=$n((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;ro(t=Xi(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),Xs=function(){function t(){se(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return he(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");ro(n=Wo(i=[]).call(i,Yo(this._subscribers[t]),Yo(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Wt(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),Ws=(ys("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Os),L.Set);function Gs(t,e){var r;if(void 0===Go||null==Dn(t)){if(Do(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Vs(t,e);var n=No(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Wn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Vs(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=Pn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Vs(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var Hs=function(){function t(e){se(this,t),this._pairs=e}return he(t,[{key:Fu,value:Nu.mark((function t(){var e,r,n,i,o;return Nu.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Gs(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=jo(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Nu.mark((function t(){var e,r,n,i,o;return Nu.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Gs(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=jo(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Nu.mark((function t(){var e,r,n,i;return Nu.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Gs(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=jo(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Nu.mark((function t(){var e,r,n,i;return Nu.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Gs(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=jo(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Ft(t=Yo(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Ft(t=Yo(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Yo(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=ii(null),r=Gs(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=jo(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Ss(this._pairs)}},{key:"toIdSet",value:function(){return new Ws(this.toIdArray())}},{key:"toItemSet",value:function(){return new Ws(this.toItemArray())}},{key:"cache",value:function(){return new t(Yo(this._pairs))}},{key:"distinct",value:function(t){var e,r=new Ws,n=Gs(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=jo(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(ai({},Fu,Nu.mark((function t(){var n,i,o,a,u;return Nu.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Gs(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(o=jo(i.value,2),a=o[0],u=o[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=Gs(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=jo(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(ai({},Fu,Nu.mark((function t(){var n,i,o,a,u;return Nu.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Gs(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return o=jo(i.value,2),a=o[0],u=o[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Pn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=jo(r.value,2),a=o[0],u=o[1],s=t(u,a);s>i&&(i=s,n=u)}return n}},{key:"min",value:function(t){var e=Pn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=jo(r.value,2),a=o[0],u=o[1],s=t(u,a);s<i&&(i=s,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=Gs(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=jo(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(ai({},Fu,(function(){var t;return Pn(Qu(t=Yo(r._pairs)).call(t,(function(t,r){var n=jo(t,2),i=n[0],o=n[1],a=jo(r,2),u=a[0],s=a[1];return e(o,s,i,u)})))})))}}]),t}();function $s(t,e){var r=Po(t);if(rn){var n=rn(t);e&&(n=Wt(n).call(n,(function(e){return Fe(t,e).enumerable}))),r.push.apply(r,n)}return r}function Js(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)ro(r=$s(Object(n),!0)).call(r,(function(e){ai(t,e,n[e])}));else if(Ce)Ae(t,Ce(n));else{var i;ro(i=$s(Object(n))).call(i,(function(e){ye(t,e,Fe(n,e))}))}}return t}function Qs(t,e){var r;if(void 0===Go||null==Dn(t)){if(Do(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Bs(t,e);var n=No(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Wn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Bs(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=Pn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Bs(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Ks(t){var e=function(){if("undefined"==typeof Reflect||!Du)return!1;if(Du.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Du(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Ls(t);if(e){var i=Ls(this).constructor;r=Du(n,arguments,i)}else r=n.apply(this,arguments);return Ps(this,r)}}var Zs=function(t){As(r,Xs);var e=Ks(r);function r(t,n){var i;return se(this,r),(i=e.call(this))._queue=null,t&&!Do(t)&&(n=t,t=[]),i._options=n||{},i._data=new Ss,i.length=0,i._idProp=i._options.fieldId||"id",t&&t.length&&i.add(t),i.setOptions(n),i}return he(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=Us.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Ro(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(Do(t)){var o=Ft(t).call(t,(function(t){return t[n._idProp]}));if(as(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Ro(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],u=this._idProp,s=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var s=t,c=Mi({},r._data.get(e)),l=r._updateItem(s);i.push(l),a.push(s),o.push(c)}else{var f=r._addItem(t);n.push(f)}};if(Do(t))for(var c=0,l=t.length;c<l;c++)t[c]&&"object"===Ro(t[c])?s(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Ro(t))throw new Error("Unknown dataType");s(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var f={items:i,oldData:o,data:a};this._trigger("update",f,e)}return Wo(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;Do(t)||(t=[t]);var i=Ft(r=Ft(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Eu.apply(void 0,Wo(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:Ft(i).call(i,(function(t){return t.id})),oldData:Ft(i).call(i,(function(t){return t.oldData})),data:Ft(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;Ys(t)?(r=t,i=e):Do(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",u=i&&Wt(i),s=[],c=void 0,l=void 0,f=void 0;if(null!=r)(c=this._data.get(r))&&u&&!u(c)&&(c=void 0);else if(null!=n)for(var h=0,p=n.length;h<p;h++)null==(c=this._data.get(n[h]))||u&&!u(c)||s.push(c);else for(var v,d=0,y=(l=Yo(ts(v=this._data).call(v))).length;d<y;d++)f=l[d],null==(c=this._data.get(f))||u&&!u(c)||s.push(c);if(i&&i.order&&null==r&&this._sort(s,i.order),i&&i.fields){var g=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,b=s.length;m<b;m++)s[m]=this._filterFields(s[m],g)}if("Object"==a){for(var _={},w=0,E=s.length;w<E;w++){var O=s[w];_[O[this._idProp]]=O}return _}return null!=r?null!==(o=c)&&void 0!==o?o:null:s}},{key:"getIds",value:function(t){var e=this._data,r=t&&Wt(t),n=t&&t.order,i=Yo(ts(e).call(e)),o=[];if(r)if(n){for(var a=[],u=0,s=i.length;u<s;u++){var c=i[u],l=this._data.get(c);null!=l&&r(l)&&a.push(l)}this._sort(a,n);for(var f=0,h=a.length;f<h;f++)o.push(a[f][this._idProp])}else for(var p=0,v=i.length;p<v;p++){var d=i[p],y=this._data.get(d);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=i.length;m<b;m++){var _=i[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,E=g.length;w<E;w++)o.push(g[w][this._idProp])}else for(var O=0,S=i.length;O<S;O++){var T=i[O],x=e.get(T);null!=x&&o.push(x[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Wt(e),n=this._data,i=Yo(ts(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,u=o.length;a<u;a++){var s=o[a];t(s,s[this._idProp])}else for(var c=0,l=i.length;c<l;c++){var f=i[c],h=this._data.get(f);null==h||r&&!r(h)||t(h,f)}}},{key:"map",value:function(t,e){for(var r=e&&Wt(e),n=[],i=this._data,o=Yo(ts(i).call(i)),a=0,u=o.length;a<u;a++){var s=o[a],c=this._data.get(s);null==c||r&&!r(c)||n.push(t(c,s))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?te(r=Do(e)?e:Po(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;Qu(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");Qu(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=Do(t)?t:[t],o=0,a=i.length;o<a;o++){var u=this._remove(i[o]);if(u){var s=u[this._idProp];null!=s&&(r.push(s),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(Ys(t)?e=t:t&&"object"===Ro(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Yo(ts(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=Qs(Uu(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u>i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=Qs(Uu(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u<i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Yo(ts(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var u=r[o],s=e.get(u)[t],c=!1,l=0;l<i;l++)if(n[l]==s){c=!0;break}c||void 0===s||(n[i]=s,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=qs()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+ei(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,Js(Js({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Hs(ai({},Fu,Nu.mark((function r(){var n,i,o,a;return Nu.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Qs(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Hs(ai({},Fu,ue(r=Mu(this._data)).call(r,this._data)))}},{key:"idProp",get:function(){return this._idProp}}]),r}();function tc(t,e){var r;if(void 0===Go||null==Dn(t)){if(Do(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return ec(t,e);var n=No(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Wn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ec(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=Pn(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function ec(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function rc(t){var e=function(){if("undefined"==typeof Reflect||!Du)return!1;if(Du.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Du(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Ls(t);if(e){var i=Ls(this).constructor;r=Du(n,arguments,i)}else r=n.apply(this,arguments);return Ps(this,r)}}var nc=function(t){As(r,Xs);var e=rc(r);function r(t,n){var i,o;return se(this,r),(o=e.call(this)).length=0,o._ids=new Ws,o._options=n||{},o._listener=ue(i=o._onEvent).call(i,js(o)),o.setData(t),o}return he(r,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Wt(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Wt(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new Zs;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Wt(this._options)}),e=Yo(this._ids),r={},n=[],i=[],o=[],a=0,u=t.length;a<u;a++){var s=t[a];r[s]=!0,this._ids.has(s)||(n.push(s),this._ids.add(s))}for(var c=0,l=e.length;c<l;c++){var f=e[c],h=this._data.get(f);null==h?console.error("If you see this, report it please."):r[f]||(i.push(f),o.push(h),this._ids.delete(f))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;Ys(t)||Do(t)?(n=t,r=e):r=t;var i=Mi({},this._options,r),o=Wt(this._options),a=r&&Wt(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Wt(this._options),n=null!=t?Wt(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Wt(this._options),o=e&&Wt(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,ro(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Wt(this._options),o=e&&Wt(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,Ft(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||ai({},Fu,ue(e=ts(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",i={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=tc(Mo(r.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;ye(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],u=[],s=[],c=[];switch(t){case"add":for(var l=0,f=n.length;l<f;l++){var h=n[l];this.get(h)&&(this._ids.add(h),i.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(o.push(d),s.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),i.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),c.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:u,data:s},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}},{key:"idProp",get:function(){return this.getDataSet().idProp}}]),r}();function ic(t,e){return"object"===Ro(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof ro(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Ft(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function oc(t,e){return"object"===Ro(e)&&null!==e&&t===e.idProp&&"function"==typeof ro(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Ft(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&ic(t,e.getDataSet())}export{wu as DELETE,Zs as DataSet,Hs as DataStream,nc as DataView,Us as Queue,pe as createNewDataPipeFrom,ic as isDataSetLike,oc as isDataViewLike};
//# sourceMappingURL=vis-data.min.js.map
